#!/usr/bin/perl

use Mcexitexchange;
use CGI::Carp qw(fatalsToBrowser);
use CGI qw(:standard);

$dbh = Mcexitexchange->connect_database();
&signup_error("The username is too long.", param('first_name'), param('last_name'), param('email'), param('referrer'))
	if length(param('username')) > 14;
&signup_error("The username is too short.", param('first_name'), param('last_name'), param('email'), param('referrer'))
	if length(param('username')) < 3;
&signup_error("Please enter your first name!", param('first_name'), param('last_name'), param('email'), param('referrer'))
	unless param('first_name');
&signup_error("Please enter your last name!", param('first_name'), param('last_name'), param('email'), param('referrer'))
	unless param('last_name');
&signup_error("The first name you entered is too long!", param('first_name'), param('last_name'), param('email'), param('referrer'))
	if length(param('first_name')) > 16;
&signup_error("The last name you entered is too long!", param('first_name'), param('last_name'), param('email'), param('referrer'))
	if length(param('last_name')) > 16;
&signup_error("You entered two different passwords!", param('first_name'), param('last_name'), param('email'), param('referrer'))
	unless param('pass1') eq param('pass2');
&signup_error("The password you entered is either too short or too long!", param('first_name'), param('last_name'), param('email'), param('referrer'))
	if length(param('pass1')) < 5 or length(param('pass1')) > 14;
&signup_error("The E-Mail you entered is too long!", param('first_name'), param('last_name'), param('email'), param('referrer'))
	if length(param('email')) > 60;
$username = lc(param('username'));
$password = lc(param('pass1'));
$referrer = lc(param('referrer'));
$first_name = param('first_name');
$last_name = param('last_name');
$email = param('email');
if (defined($dbh->selectrow_array("SELECT signup_date FROM users WHERE username = '$username'")))
{
 &signup_error("The username you have chosen already exists in our system!", param('first_name'), param('last_name'), param('email'), param('referrer'));
}
@salt = ('a'..'z', 'A'..'Z', 0..9);
$salt = $salt[rand @salt] . $salt[rand @salt];
$password_crypted = crypt($password, $salt);
(undef, undef, undef, $day, $month, $year) = localtime(time());
$month++;
$year += 1900;
$signup_date = "$year-$month-$day";
if (defined($dbh->selectrow_array("SELECT signup_date FROM users WHERE username = '$referrer'")))
{
 my $old_referrals = $dbh->selectrow_array("SELECT referrals FROM users WHERE username = '$referrer'");
 $old_referrals .= $old_referrals ? '&' . $username : $username;
 $dbh->do("UPDATE users SET referrals = '$old_referrals' WHERE username = '$referrer'");
}
else
{
 $referrer = undef;
}
$dbh->do("INSERT INTO users (username, password, first_name, last_name, email, signup_date, referrer, credits, total_visits, credits_earned) VALUES ('$username', '$password_crypted', '$first_name', '$last_name', '$email', '$signup_date', '$referrer', 0, 0, 0)")
 or die "Couldn't insert data in MySQL table\n";
$dbh->do("UPDATE system SET usercount = usercount + 1 WHERE topic = 'system'") or die "Couldn't set usercount!\n";
$from = $dbh->selectrow_array("SELECT mail_from FROM system WHERE topic = 'system'");
$to = param('email');
$subject = $dbh->selectrow_array("SELECT register_mailsubject FROM system WHERE topic = 'system'");
$body = $dbh->selectrow_array("SELECT register_mailbody FROM system WHERE topic = 'system'");
open (MAIL,"|$Mcexitexchange::sendmail_path -t");
print MAIL "To: $to\n";
print MAIL "From: $from\n";
print MAIL "Subject: $subject\n\n";
print MAIL "$body\n";
close MAIL;
print Mcexitexchange->template(file => 'templates/successful_registration.html');
Mcexitexchange->disconnect_database($dbh);

sub signup_error
{
  my ($error, $first_name, $last_name, $email, $referrer) = @_;
  my $signup_form = "<form action=register.pl method=post><table width=\"90%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\">
								<tr>
								<td width=\"50%\">
									<div align=\"right\">
									<font><b>Username&nbsp;(3-14 characters):</b></font></div>
								</td>
								<td><input value=\"$username\" type=text name=username size=20 maxlength=14></td>
							</tr>
								<tr>
								<td width=\"50%\">
									<div align=\"right\">
									<font><b>Password&nbsp;(5-14 characters):</b></font></div>
								</td>
								<td><input type=password name=pass1 size=20 maxlength=14></td>
							</tr>
								<tr>
								<td width=\"50%\">
									<div align=\"right\">
									<font><b>Repeat password:</b></font></div>
								</td>
								<td><input type=password name=pass2 size=20 maxlength=14></td>
							</tr>
							<tr>
								<td width=\"50%\">
									<div align=\"right\">
									<font><b>First name:</b></font></div>
								</td>
								<td><input type=text value=\"$first_name\" name=first_name size=20 maxlength=16></td>
							</tr>
							<tr>
								<td width=\"50%\">
									<div align=\"right\">
									<font><b>Last name:</b></font></div>
								</td>
								<td><input type=text value=\"$last_name\" name=last_name size=20 maxlength=16></td>
							</tr>
							<tr>
								<td width=\"50%\">
									<div align=\"right\">
									<font><b>E-Mail:</b></font></div>
								</td>
								<td><input type=text value=\"$email\" name=email size=30 maxlength=60>
								<input type=hidden name=referrer value=\"$referrer\">
								</td>
							</tr>
								<tr>
									<td colspan=\"2\"><br>
										<div align=\"center\">
											<input type=submit value=\"Sign Up!\">
										</div>
									</td>
								</tr>
							</table></form>";
 print Mcexitexchange->template(file => 'templates/signup_error.html', error => $error, form => $signup_form) or die "Couldn't open Mcexitexchange->template!";
 Mcexitexchange->disconnect_database($dbh);
 exit;
}
